int stage;
#include <allegro.h>
int d11;
/*65816*/
typedef union
{
        unsigned short w;
        struct { unsigned char l,h; } b;
} reg;

reg a,x,y,s;
unsigned short pc,dp;
unsigned char pbr,dbr;
int mode;
int nmiena;
int setzf;

struct
{
        int c,z,i,d,v,n,x,m,e;
} p;

int gcycs;

/*I/O*/
void writeio(unsigned short addr, unsigned char val);
int nmiocc;
struct
{
        unsigned short src[8],size[8];
        unsigned char srcbank[8],ctrl[8],dest[8];
} dma;
int vertint,vertline;
int horint;

/*Memory*/
unsigned char *mempoint[256][8];
int mempointv[256][8],mempointw[256][8];
int accesslook[256][128];
unsigned char readmeml(unsigned char b, unsigned short addr);
extern inline unsigned char readmem(unsigned char b, unsigned short a)
{
        gcycs-=accesslook[b][a>>9];
        if ((((1364-gcycs)>>2)&~3)==0x80) gcycs-=40;
        return ((mempointv[b&255][((a)&0xFFFF)>>13])?mempoint[b&255][((a)&0xFFFF)>>13][(a)&0x1FFF]:readmeml(b,a));
}
//#define readmem(b,a)    ((mempointv[b&255][((a)&0xFFFF)>>13])?mempoint[b&255][((a)&0xFFFF)>>13][(a)&0x1FFF]:readmeml(b,a))
#define writemem(b,a,v) {if (mempointw[b&255][((a)&0xFFFF)>>13]) { gcycs-=accesslook[b][a>>9]; if ((((1364-gcycs)>>2)&~3)==0x80) gcycs-=40; mempoint[b&255][((a)&0xFFFF)>>13][(a)&0x1FFF]=v; } else {writememl(b,a,v);} }
/*if (a==0x163B || a==0x22A) printf("%04X write %02X %02X:%04X %06X\n",a,v,pbr,pc,(ram[s.w+1]|(ram[s.w+2]<<8)|(ram[s.w+3]<<16))+1); if (b==0x7F && (a&0xFFFF)==0x49) printf("7F0049 write %02X %02X:%04X %04X\n",v,pbr,pc,(ram[s.w+1]|(ram[s.w+2]<<8))+1); */
/*PPU*/
void writeppu(unsigned short addr, unsigned char val);
void initppu();
int vbl;
typedef struct
{
        unsigned char vidportc,sdr;
        unsigned char main,sub;
        unsigned char *vram;
        unsigned short *vramw;
        unsigned short vaddr;
        unsigned short bg[4],chr[4];
        int xs[4],ys[4];
        int vinc,mode;
        BITMAP *b;
        BITMAP *s;
        PALETTE pal;
        unsigned short cgramaddr;
        unsigned char cgram[512];
        int paldirty[256];
        unsigned long coltable[8],coltable16[8];
        unsigned long bittable[2][16],masktable[2][16];
        int firstread;
        unsigned long wramaddr;
        unsigned char cgwsel,cgadsub,fixedcol;
        int fgcount,fgmask,fgshift;
        unsigned char wobjsel;
        int w1l,w1r,w2l,w2r;
} PPU;

PPU ppu;
unsigned char hdmaena;
int xmode[4],ymode[4],xsize[4],bgdat[4];
int curline;

unsigned short sprchraddr;
unsigned char objram[1024];
unsigned short objaddr;
int firstobjwrite;
int subscreenon,bg3on;

struct
{
        int hdmaon[8];
        int hdmacount[8];
        unsigned long hdmaval[8];
        unsigned char srcbank[8];
        unsigned short src[8];
        int repeat[8];
        unsigned char ibank[8];
        unsigned short ta[8];
} hdma;

struct
{
        unsigned short bg[4],chr[4];
        int mode,screenon;
        int mask;
        int mainena,subena;
        int bg3pri;
        int xs[4],ys[4];
        int tsize[4],xsize[4],ysize[4];
        int bright;
        unsigned short m7a,m7b,m7c,m7d,m7x,m7y;
        int m7change;
        unsigned char m7sel;
        unsigned char mosaic,mena;
        unsigned char cgwsel,cgadsub;
        unsigned char fixedcol,wobjsel;
        int w1l,w1r,w2l,w2r;
        int wchg;
} lines[224];

/*DSP*/
unsigned char dspregs[128];
int dspaddr;
