#include <allegro.h>

int output;
int romsloaded=0;
MENU videomenu[3],configmenu[3],mainmenu[3];
int romloaded,exitsnem,spcemu,lorom,bit16;
unsigned char *ram;
int nmiena,countena,vertint,horint;

int loadrom()
{
        char filename[1024];
        filename[0]=0;
        file_select_ex("Please choose a ROM image",filename,"SMC",1024,320,240);
        loadsmc(filename);
        romloaded=1;
        if (!lorom) makehiromtable();
        else        makeloromtable();
        reset65816();
        resetspc();
        resetppu();
        memset(ram,0,131072);
        dumpregs();
        romsloaded++;
//        if (romsloaded==2) output=1;
        nmiena=countena=vertint=horint=0;
        return D_CLOSE;
}

int resetm()
{
        reset65816();
        return D_CLOSE;
}

int returnm()
{
        return D_CLOSE;
}

int exitm()
{
        exitsnem=1;
        return D_CLOSE;
}

MENU filemenu[]=
{
        {"&Load ROM",loadrom,NULL,NULL,NULL},
        {"&Reset",resetm,NULL,NULL,NULL},
        {"Return",returnm,NULL,NULL,NULL},
        {"&Exit",exitm,NULL,NULL,NULL},
        {NULL,NULL,NULL,NULL,NULL}
};

int bit8()
{
        bit16=0;
        return D_O_K;
}
int bit16m()
{
        bit16=1;
        return D_O_K;
}

MENU videomenu[]=
{
        {"8 bit colour",bit8,NULL,NULL,NULL},
        {"16 bit colour",bit16m,NULL,NULL,NULL},
        {NULL,NULL,NULL,NULL,NULL}
};

int soundena()
{
        spcemu^=1;
        return D_O_K;
}

MENU configmenu[]=
{
        {"&Sound enable",soundena,NULL,NULL,NULL},
        {"&Video mode",NULL,videomenu,NULL,NULL},
        {NULL,NULL,NULL,NULL,NULL}
};

MENU mainmenu[]=
{
        {"&File",NULL,filemenu,NULL,NULL},
        {"&Config",NULL,configmenu,NULL,NULL},
        {NULL,NULL,NULL,NULL,NULL}
};

DIALOG snemgui[]=
{
        {d_ctext_proc, 200, 292, 0,  0, 0,15,0,0,     0,0,"Snem v0.1"},
        {d_menu_proc,  0,   0,   0,  0, 0,15,0,0,     0,0,mainmenu},
        {0,0,0,0,0,0,0,0,0,0,0,NULL,NULL,NULL}
};

void entergui()
{
        set_mouse_range(0,0,399,299);
        set_mouse_sprite(NULL);
        gui_fg_color=makecol(255,255,255); gui_bg_color=makecol(0,0,0);
        snemgui[0].fg=makecol(255,255,255); snemgui[0].bg=makecol(0,0,0);
        clear_keybuf();
        do_dialog(snemgui,0);
        clear(screen);
}
